
from MsgEvent import MsgEvent
from Game import Game
from Player import Player, Independent
from Protocol import UndefProto
from Selecting.log import log
from Selecting.TCPServer import ConnectionSocket

class Server:
	def __init__(self):
		self.games = {}
		self.players = { 0 : Independent() }
		self.gamelistenerplyrs = []
		self.nxgame = 1
		self.nxplayer = 1
		self.name = "GalaxIEs"
		self.commands = {	'MESG' : self.recv_message }

	def new_conn_socket(self, socket, handler):
		return ConnectionSocket(socket, handler)

	def new_conn_handler(self, srv):
		return UndefProto(self.found_player())

	def get_game(self, id):
		return self.games[id]

	def get_or_found_game(self, id, querier):
		try:
			return self.get_game(id)
		except KeyError:
			game = Game(self, self.nxgame, querier)
			self.games[self.nxgame] = game
			log( 5, "Creating new game %d" % self.nxgame )
			self.nxgame = self.nxgame + 1
			return game

	def get_player(self, id):
		return self.players[id]

	def send_listenerbc(self, event):
		for p in self.gamelistenerplyrs:
			p.send_event(event)

	def found_player(self):
		plyr = Player(self, self.nxplayer)
		self.players[self.nxplayer] = plyr
		log( 5, "Creating new player %d" % self.nxplayer )
		self.nxplayer = self.nxplayer + 1
		return plyr

	def list_games(self, plyr):
		plyr.send_event(MsgEvent('BGML'))
		for g in self.games.values():
			map(plyr.send_event, g.get_selfaseventlist())
		plyr.send_event(MsgEvent('EGML'))
		self.gamelistenerplyrs.append(plyr)

	def unreg_player_as_gamelistener(self, plyr):
		if plyr in self.gamelistenerplyrs:
			self.gamelistenerplyrs.remove(plyr)

	def list_players(self, phnd):
		phnd.send_event(MsgEvent('BPYL'))
		for p in self.players.keys():
			phnd.send_event(self.players[p].get_selfasevent('GPLR'))
		phnd.send_event(MsgEvent('EPYL'))

	def unreg_game(self, id):
		try:
			del self.games[id]
			log( 5, "Deleting game %d" % id )
		except KeyError:
			pass

	def unreg_player(self, id):
		try:
			del self.players[id]
			log( 5, "Deleting player %d" % id )
		except KeyError:
			pass

	def recv_event(self, event):
		try:
			command = self.commands[event.evtype]
		except KeyError:
			event.player.send_event(MsgEvent('ERRS', name=event.evtype, \
							 desc="No handler for command"))
			return
		command(event)

	def recv_message(self, event):
		if event.tg_player == None:
			event.player.send_event(MsgEvent('ERRC', name=event.evtype, \
							 desc="Ambiguous send"))
			return
		event.tg_player.send_event(MsgEvent('PMSG', player=event.player, desc=event.desc))

